Last Comment Bug 538500 - Do Not Allow Home Button To Be Dragged and Dropped Onto Itself
: Do Not Allow Home Button To Be Dragged and Dropped Onto Itself
Status: RESOLVED FIXED
:
Product: SeaMonkey
Classification: Client Software
Component: UI Design (show other bugs)
: Trunk
: All All
: -- minor (vote)
: seamonkey2.1b3
Assigned To: Jens Hatlak (:InvisibleSmiley)
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2010-01-07 17:22 PST by David E. Ross
Modified: 2011-02-28 10:34 PST (History)
1 user (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
image of popup (5.25 KB, image/jpeg)
2010-01-07 17:26 PST, David E. Ross
no flags Details
patch (1.04 KB, patch)
2011-02-27 13:16 PST, Jens Hatlak (:InvisibleSmiley)
no flags Details | Diff | Splinter Review
patch v2 [Checkin: comment 12] (1.29 KB, patch)
2011-02-27 14:24 PST, Jens Hatlak (:InvisibleSmiley)
neil: review+
Details | Diff | Splinter Review

Description David E. Ross 2010-01-07 17:22:09 PST
User-Agent:       Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.1.6) Gecko/20091206 SeaMonkey/2.0.1
Build Identifier: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.1.6) Gecko/20091206 SeaMonkey/2.0.1

When I select the Home button, I sometimes get a popup asking if I want to set my home page.  I have already set my home page to be my bookmarks file (bookmarks.html).  

If I select the Set Home Page button on the popup, the result is that my bookmarks file remains my home page.  That is, the dialogue chooses the page to which I am going, not the page from which I am leaving.  

Reproducible: Sometimes




My Home button is on my Navigation toolbar.  I moved it there from my Personal toolbar, which I normally hide.
Comment 1 David E. Ross 2010-01-07 17:26:56 PST
Created attachment 420652 [details]
image of popup
Comment 2 David E. Ross 2010-01-12 15:40:21 PST
In a newsgroup thread in mozilla.support.seamonkey, Jens Hatlak noted that the Home button can be dragged from its toolbar.  I tested that and found that I can consistently recreate this problem if my mouse moves even slightly while I'm clicking on that button.  

As already noted, I moved the Home button from my Personal toolbar to my Navigation toolbar.  However, I just tested this with the Home button restored to my Personal toolbar.  This bug remains a problem in that case.  That is, even when it is on the Preferences toolbar, the Home button can be dragged slightly and will cause the popup seen in Attachment 420652 [details].  

No button should be dragged except while the Customize Toolbar window is open.  I'm not sure if this is still a bug for the Preferences component.   

By the way, I am using SeaMonkey Default Theme 1.0.
Comment 3 David E. Ross 2010-01-12 15:58:47 PST
Oops!  Not clear.  

When I indicated "I'm not sure if this is still a bug for the Preferences component.", I meant that I'm not sure if this falls within that component.  It might be a bug for SeaMonkey's Themes component or for Toolkit's Toolbars and Toolbar Customization component.
Comment 4 Jens Hatlak (:InvisibleSmiley) 2010-01-13 10:46:50 PST
I think it's a valid move to drag the Home button, e.g. to open a new tab at a certain position. There is little to no sense in dropping it on itself, though--the Home Page already is equal to its location, so even clicking OK in the dialog that currently appears in that situation won't change anything (or rather should, I didn't check the multi-page case).

David, if you agree, please morph this bug into requesting to remove the possibility of dropping the Home button on itself (adapt the summary).

Moving over to UI Design (still better than General I guess).
Comment 5 David E. Ross 2010-01-13 15:58:34 PST
I agree.  Summary changed from "Asks to Set Home Page When It Is Already Set".  

The fix should not involve any error popup dialogue or require any user response.  Instead, dragging and dropping the button onto itself should simply be ignored.  Many users likely have an unsteady hand when selecting and clicking on a button.  

When this is fixed, it needs to be tested for Home buttons on both the Navigation and Personal toolbars.
Comment 6 Jens Hatlak (:InvisibleSmiley) 2011-02-27 13:16:11 PST
Created attachment 515508 [details] [diff] [review]
patch
Comment 7 neil@parkwaycc.co.uk 2011-02-27 13:25:55 PST
(In reply to comment #4)
> I think it's a valid move to drag the Home button, e.g. to open a new tab at a
> certain position. There is little to no sense in dropping it on itself,
> though--the Home Page already is equal to its location, so even clicking OK in
> the dialog that currently appears in that situation won't change anything (or
> rather should, I didn't check the multi-page case).
IIRC the home button only drags the first page, so you'd lose data.
Comment 8 neil@parkwaycc.co.uk 2011-02-27 13:27:38 PST
(In reply to comment #7)
> (In reply to comment #4)
> > I think it's a valid move to drag the Home button, e.g. to open a new tab at a
> > certain position. There is little to no sense in dropping it on itself,
> > though--the Home Page already is equal to its location, so even clicking OK in
> > the dialog that currently appears in that situation won't change anything (or
> > rather should, I didn't check the multi-page case).
> IIRC the home button only drags the first page, so you'd lose data.
On closer inspection, drops only change the first page too, so you don't.
Comment 9 neil@parkwaycc.co.uk 2011-02-27 13:36:52 PST
Comment on attachment 515508 [details] [diff] [review]
patch

I was wondering whether we should make it so that the button refuses to drop on itself (much as dragging a link from a page refuses to drop into the page).
Comment 10 Jens Hatlak (:InvisibleSmiley) 2011-02-27 14:24:55 PST
Created attachment 515519 [details] [diff] [review]
patch v2 [Checkin: comment 12]

(In reply to comment #9)
> I was wondering whether we should make it so that the button refuses to drop on
> itself (much as dragging a link from a page refuses to drop into the page).

I was trying something with a canDrop method, which was actually called but didn't work. Then I found the below site and tried setting aDragSession.canDrop, which didn't work either. Then I tried changing aDragSession.dragAction, which finally worked. Madness.

https://developer.mozilla.org/en/Drag_and_Drop
Comment 11 neil@parkwaycc.co.uk 2011-02-27 16:01:03 PST
Comment on attachment 515519 [details] [diff] [review]
patch v2 [Checkin: comment 12]

Maybe the other ways would have worked with the new style drag'n'drop.
Comment 12 Jens Hatlak (:InvisibleSmiley) 2011-02-28 10:33:54 PST
Comment on attachment 515519 [details] [diff] [review]
patch v2 [Checkin: comment 12]

http://hg.mozilla.org/comm-central/rev/c2a8fe26bf32

Note You need to log in before you can comment on or make changes to this bug.